/**The main routine is targeet-specific. 
 * To run on pc a main and a second thread is created here.
 * The second thread invokes step2_TestMutex(...) 
 */
#include "../src/TestMutex.h"
#include <OSAL/os_time.h>
#include <OSAL/os_thread.h>

#include <stdio.h>

typedef struct TestMutex_main_t {
  
  TestMutex testData;

  OS_HandleThread hthreadMain, hthread2;

  MinMaxTime_emC timeWork;

} TestMutex_main;

TestMutex_main maindata = {0};



int thread2Routine(void* data) {
  TestMutex_main* thiz = &maindata;
  
  STACKTRC_ENTRY("thread2Routine")
  while (true) {
    cyclTime_MinMaxTime_emC(&thiz->timeWork);
    TRY {
      workThread_TestMutex(&maindata.testData);
    }_TRY;
    CATCH(Exception, exc) {
      maindata.testData.ctCatched +=1;
    }
    END_TRY;
    calcTime_fast_MinMaxTime_emC(&thiz->timeWork, os_getClockCnt());
    os_delayThread(2);
  }
  STACKTRC_LEAVE; return 0;
}

void test_DelayParameterUse() {
  //os_delayThread(1);

}


void test_DelayParameterChange() {
  os_delayThreadClocks(200);

}


void main() {
  int ctMainLoop = 0;
  TestMutex_main* thiz = &maindata;
  STACKTRC_ROOT_ENTRY("main");
  init_MinMaxTime_emC(&thiz->timeWork);
  
  float microsecondsTick = os_measureClock();
  printf("The system clock is %f microseconds per tick\n", microsecondsTick);

  ctor_TestMutex(&thiz->testData);
  //os_delayThread(1);
  thiz->hthreadMain = os_getCurrentThreadHandle();
  os_createThread(&maindata.hthread2, thread2Routine, null, "thread2", 0xc0, 0);
  int prioMain = os_getOsThreadPriority(thiz->hthreadMain);
  int prio2 = os_getOsThreadPriority(thiz->hthread2);

  int ctErrorMirror = 0;
  while (++ctMainLoop < 500) {

    calculateParameter_TestMutex(&maindata.testData);
    os_delayThread(10);
    if((ctMainLoop %10 == 0)){
      printf(ctErrorMirror != thiz->testData.ctError ? "!" : "*");
      ctErrorMirror = thiz->testData.ctError;
    }

  }
  //int abortError = 1000;
  //while(  maindata.testData.ctUsage < ctMainLoop 
  //     && --abortError >=0  //any while loop should be deterministic in its context!
  //     ) {
  //  os_delayThread(1);  //wait till all usings are done.
  //}

  os_delayThread(1);  //wait till all usings are done.
  printf("\noK: %d, error: %d\n", thiz->testData.ctOk, thiz->testData.ctError)
  STACKTRC_LEAVE;
}
