
#include "TestMutex.h"
#include <msp430.h>
#include <OSAL/os_time.h>


typedef struct TestMutex_main_t {

  TestMutex testData;

  MinMaxTime_emC intrTimeMeasurement;


} TestMutex_main;

TestMutex_main maindata = {0};



typedef struct ThCxt_Application_t {

  ThreadContext_emC_s* currThCxt;

  ThreadContext_emC_s thCxtMain;

  ThreadContext_emC_s thCxtIntr1;

  ThreadContext_emC_s thCxtIntr2;

}ThCxt_Application_s;


ThCxt_Application_s thCxtAppl_g = { &thCxtAppl_g.thCxtMain, { 0 }, { 0 }, { 0 } };

ThreadContext_emC_s* getCurrent_ThreadContext_emC()
{
  return thCxtAppl_g.currThCxt;
}



void test_DelayParameterChange(){
  os_delayThread(10); //delay of 10 ms
}

void test_DelayParameterUse(){

}





void main(){
  //Initialize timer A 0 as interrupt source.
  WDTCTL = WDTPW | WDTHOLD;

  STACKTRC_ROOT_ENTRY("main");
  //all interrupts use the same stack!
  thCxtAppl_g.thCxtIntr1.topmemAddrOfStack = _thCxt->topmemAddrOfStack;
  thCxtAppl_g.thCxtIntr2.topmemAddrOfStack = _thCxt->topmemAddrOfStack;

  P1DIR = BIT0 | BIT6; //LED output

  P1OUT = 0;

  init_MinMaxTime_emC(&maindata.intrTimeMeasurement);
  ctor_TestMutex(&maindata.testData);

  TA0CCTL0 = CCIE;    //Timer A config.
  TA0CCR0 = 16000;    //1 ms interrupt on 16 MHz clock
  TA0CCTL1 = CCIE;
  TA0CCR1 = 6000;    //1 ms interrupt on 16 MHz clock

  TA0CTL =            //Timer A Control
           MC_2       //Mode 2: continues from 0 to 0xffff->0
         | TASSEL_2   //Clock select
         | ID_3;      //Input divider 8, It is 8 us base clock

  __enable_interrupt();
  while(true) {
    calculateParameter_TestMutex(&maindata.testData);
    P1OUT ^= BIT6;
    os_delayThread(100);  //action after about 100 ms.
  }
  _BIS_SR(LPM0_bits | GIE);
  STACKTRC_LEAVE;

}

//The next interrupt function is for this vector, Timer A0
#pragma vector=TIMER0_A0_VECTOR
__interrupt void Timer_A(){   //interrupt for TA0CCTL0
  //set the correct ThreadContext for the interrupt routine:
  ThreadContext_emC_s* thCxtRestore = thCxtAppl_g.currThCxt;
  thCxtAppl_g.currThCxt = &thCxtAppl_g.thCxtIntr1;
  cyclTime_MinMaxTime_emC(&maindata.intrTimeMeasurement);
  __enable_interrupt();

  P1OUT ^= BIT0;           //toggled led
  TA0CCTL0 &= ~CCIFG;      //reset interrupt flag (necessary!)
  TA0CCR0 += 500;         //next interrupt time, it is appr 5000 * 0.008 = 40 ms
  workThread_TestMutex(&maindata.testData);

  calcTime_fast_MinMaxTime_emC(&maindata.intrTimeMeasurement, os_getClockCnt());
  //restore the ThreadContext on return:
  thCxtAppl_g.currThCxt = thCxtRestore;
}

//The next intterupt function is for this vector, TA0CCTL1
#pragma vector=TIMER0_A1_VECTOR
__interrupt void Timer_A1(){
    TA0CCTL1 &= ~CCIFG;
//  step2_TestMutex(&maindata.testData);
}
