#ifndef __TestMutex_h__
#define __TestMutex_h__
#include <OSAL/os_sync.h>

typedef struct TestMutex_t {

  struct OS_Mutex_t* mutex;

  int16 x1;

  int16 bWrParam;

  int16 data1, data2;

  int16 datasum;

  /**Counts the write action. */
  int16 ctWriteParem;

  /**Interrupt while parameter are written, they are inconsistent. */
  int16 ctIntrWrParam;

  /** Counts the using result, without and witn error. */
  int16 ctOk, ctError;

  /**Counts whether the CATCH clause is detect on ctError. */
  int16 ctCatched;

  int16 ctUsage, ctUsageOk;

  int16 spare; //only to fill 4/8-byte-aligned.


} TestMutex;


void ctor_TestMutex(TestMutex* thiz);


/**This routine is an example to calculate and store parameter. 
 * It can be called in the main loop or a lower priority thread. 
 * The parameter are used consistent, therefore a mutex while writing is necessary.
 */
void calculateParameter_TestMutex(TestMutex* thiz);



void workThread_TestMutex(TestMutex* thiz);



/**This routine is called either in a second thread or in interrupt. 
 * It uses the consistent parameter. To prevent a thread switch to the thread
 * which changes the parameter while accessing, a mutex is used. 
 */
void useParameter_TestMutex(TestMutex* thiz);





#endif // __TestMutex_h__
