#include "TestReflection.h"

#include <OSAL/os_time.h>

#ifndef __DONOTUSE_REFLECTION__
  #define __Use_Inspector__
  #include <Inspc/Service_Inspc.h>
  #include <InspcJ2c/Inspector_Inspc.h>
  #include <Inspc/DataNode_Inspc.h>
#endif

#include <stdio.h>


#ifdef __DONOTUSE_REFLECTION__
char const reflection_MyData[] = "REFLMyData";
#else
#include "../genRefl/TestReflection.crefl"
//ClassJc const reflection_MyData = {0};

#endif


struct { ObjectArrayJc head; int32 data[100]; } myArray = { INIZ_ObjectArrayJc(myArray, 100, int32, REFLECTION_int32, 0) };

TestUnion testUnion = {0};

//Hint: CONST_MyData is a define which follows with { { ....} ...} the typedef of Mydata.
//The using of the macor of user level should present only the important things.
MyData data = INIZ_MyData(data, &reflection_MyData, &testUnion);


//METHOD_C void throw_sJc_(char const* exceptionNr, StringJc msg, int value, int line);

#ifdef __Use_Inspector__
//The inspector service, it is a part of the runtime environment.
Inspector_Inspc_s theInspector = { 0 };
DataNode_Inspc rootData = { 0 };

//struct FBaccess_Inspc_t* inspc;

#endif //__Use_Inspector__

int main(int nArgs, char** sArgs) {
  STACKTRC_ENTRY("main");

#ifdef __Use_Inspector__
  ctor_DataNode_Inspc(&rootData, 100, 1.0f);
  ctorO_Inspector_Inspc(&theInspector.base.object, s0_StringJc("UDP:0.0.0.0:60094"), _thCxt);
  init_ObjectJc(&theInspector.base.object, sizeof(theInspector), 0);
  addObj_DataNode_Inspc(&rootData, z_StringJc("main_data"), z_StringJc(""), &data.base.object, null);
  //addObjRefl_DataNode_Inspc(&rootData, z_StringJc("simTime"), z_StringJc(""), &maindata.simTime, &reflection_SimTime_Fwc);
  start_Inspector_Inspc_F(&theInspector, &rootData.object, _thCxt);
#endif //__Use_Inspector__

  data.base.super.bRun = 1;

  TRY {
  test_MyData(&data, 333);
  testTry(&data);
  }_TRY 
  CATCH(Exception, exc) {
    printStackTrace_ExceptionJc(exc, _thCxt);
  }END_TRY;

  calculateInLoop(&data);    //to test reflection access via inspector.
  STACKTRC_LEAVE; return 0;
}

void calculateInLoop(MyData* thiz) {
  thiz->a = 5.1f;   //exampledata
  thiz->b = 7.5f;  
  while (thiz->base.super.bRun) {
    thiz->y = thiz->a * thiz->b;
    thiz->nested.x = thiz->y +1;;
    os_delayThread(1);
  }

}


void test_MyData(MyData* thiz, float val){
  STACKTRC_ENTRY("test_MyData");
  thiz->array[0] = val;
  float* array1 = thiz->array; //not recommended, size is unknown.
  CALLINE;
  //array1 = null;               //faulty, forces asynchron exception
  array1[1] = 5.0f * val;
  STACKTRC_LEAVE;
}



/**This routine contains a TRY...CATCH and continues work. */
float testTry(MyData* thiz) {
  STACKTRC_ENTRY("testTry");
  float val;
  TRY{
    val = testTryLevel2(thiz, _thCxt);
  }_TRY
  CATCH(ClassCastException, exc) {
    //It is not recommended to do printStacktrace in normal case
    //because the exception is handled here. Only for debug, it may be important.
    printStackTrace_ExceptionJc(exc, _thCxt);
    //But save a log entry may be proper if the exception is not expected:
    log_ExceptionJc(exc, __FILE__, __LINE__);
    val = 0;
  }FINALLY{
    val = 1;
  }END_TRY;
  STACKTRC_LEAVE;
  return val;
}



/**It is a called routine from TRY level without catch.*/
float testTryLevel2(MyData* thiz, ThCxt* _thCxt) {
  STACKTRC_TENTRY("testTryLevel2");
  CALLINE; float val = testThrow(thiz, 10, 2.0f, _thCxt);
  STACKTRC_LEAVE;
  return val;
}



float testThrow(MyData* thiz, int ix, float val, ThCxt* _thCxt) {
  STACKTRC_TENTRY("testThrow");
  if (ix < 0 || ix >= ARRAYLEN_emC(thiz->array)) {
    char msg[40] = {0};
    snprintf(msg, sizeof(msg), "faulty index:%d for value %f", ix, val);
    //THROW(IllegalArgumentException, z_StringJc("faulty value"), (int)val);
    THROW_s0(IndexOutOfBoundsException, msg, ix);
    ix = ARRAYLEN_emC(thiz->array) -1;  //replacement on error: Store in the last element.
  }
  thiz->array[ix] = val;
  STACKTRC_LEAVE; return thiz->array[0];
}


