#ifndef __TestNumericSimple_h__
#define __TestNumericSimple_h__

//should be the first include!
#include <applstdef_emC.h>



//The ObjectJc base class is used. In an situation of TargetNumericSimple the following include is prevented
//because the guard  __ObjectJc_simple__ is set in  ObjectJc_simple.h included in TargetNumericSimple/applstdef_emC.h
//In another compilation situation this file is necessary and included.
#include <emC/Object_emC.h>


//If an application will use the reflection capability, but not for TargetNumericSimple compilation,
//the following kind of forward declaration is not disturbing. The type is only a declaration, not used,
//and the identifier is not used too. It will be used in another applstdef_emC situation. 
extern struct ClassJc_t const reflection_NotUsedHere;

typedef union TestUnion_t {
  struct { int32 a; short s; }val;
  float b;
}TestUnion;



typedef struct MyBaseBaseData_t {
  /**The struct is based on ObjectJc. In the compilation situation of targetNumericSimple
  * that is only a struct with 2 int32 elements. */
  ObjectJc obj;

  /**It is 1 on startup. Set to 0 to abort the execution. */
  int32 test;

} MyBaseBaseData;


/**CONST initializer to abstract the usage from the nested complex struct. Only this definition have to be match to the struct nesting. */
#define INIZ_MyBaseBaseData(OBJ, REFL) { INIZ_objReflId_ObjectJc(OBJ, REFL, 0), 123}


typedef struct MyBaseData_t {
  /**The struct is based on ObjectJc. In the compilation situation of targetNumericSimple
  * that is only a struct with 2 int32 elements. */
  union { MyBaseBaseData super; ObjectJc obj; };

  /**It is 1 on startup. Set to 0 to abort the execution. */
  int32 bRun : 1;

} MyBaseData;

/**CONST initializer to abstract the usage from the nested complex struct. Only this definition have to be match to the struct nesting. */
#define INIZ_MyBaseData(OBJ, REFL) { { INIZ_MyBaseBaseData(OBJ, REFL)}, 1}


typedef struct MyData_t {
  /**It is the super class for this type. */
  union { MyBaseData super; ObjectJc object; } base;

  TestUnion* testUnion;

  /**An implicit struct. */
  struct {
    /**Input values.*/
    float a,b;

    /**An output value will be calculated with a*b. */
    float y;
  };  
  float array[10];

  struct Implicit_t {
    float x;
  } nested;

} MyData;

/**CONST initializer to abstract the usage from the nested complex struct. Only this definition have to be match to the struct nesting. */
#define INIZ_MyData(OBJ, REFL, testUnion) { { INIZ_MyBaseData(OBJ, REFL)}, testUnion, { 3.5f, 7.4f }, 0 }

void test_MyData(MyData* thiz, float val);

/**This routine contains a TRY...CATCH and continues work. */
float testTry(MyData* thiz);

/**It is a called routine from TRY level without catch.*/
float testTryLevel2(MyData* thiz, ThCxt* _thCxt);

/**This routine throws on faulte index respectively does an replacing code. 
 * @return a value calculated.
 */
float testThrow(MyData* thiz, int ix, float val, ThCxt* _thCxt);

/**Calculates y = a*b; with 1 ms delay in the main thread.
 * It ends if bRun is set to 0 via external reflection access.
 */
void calculateInLoop(MyData* thiz);





#endif //__TestNumericSimple_h__
